/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#include "Bandwidth.h"

Bandwidth::Bandwidth()
{
  first = 1;
}

Bandwidth::~Bandwidth()
{
}

double Bandwidth::get(uint32_t s)
{
  double bw = 0;
  if(first)
  {
    first = 0;
    size = 0;
    ::GetSystemTimeAsFileTime((LPFILETIME)&beg);
  }
  else
  {
    size += s;
    ::GetSystemTimeAsFileTime((LPFILETIME)&end);
    uint32_t time = (end - beg) / 10000;
    if(time)
    {
      bw = (size * 8)/ time;
    }
  }
  return bw;
}


