/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#include <vcl.h>
#pragma hdrstop

#include "Protection.h"
#include "sess.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TProtectionForm *ProtectionForm;
//---------------------------------------------------------------------------
__fastcall TProtectionForm::TProtectionForm(TComponent* Owner)
    : TForm(Owner)
{
  password = "";
}
//---------------------------------------------------------------------------
void __fastcall TProtectionForm::OnOK(TObject *Sender)
{
  if(mode)
  {
    isOk = (password == Pass->Text);
  }
  else
  {
    password = Pass->Text.Trim();
  }
  Close();
}
//---------------------------------------------------------------------------
bool __fastcall TProtectionForm::SetPassword()
{
  mode = 0;
  ShowModal();
  return !password.IsEmpty();
}
//---------------------------------------------------------------------------
bool __fastcall TProtectionForm::GetPassword()
{
  if(password.IsEmpty())
  {
    isOk = true;
  }
  else
  {
    isOk = false;
    mode = 1;
    Pass->Text = "";
    ShowModal();
  }
  return isOk;
}
//---------------------------------------------------------------------------
void __fastcall TProtectionForm::FormShow(TObject *Sender)
{
  Pass->SetFocus();
}
//---------------------------------------------------------------------------

