/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef AACEncoderH
#define AACEncoderH

#include "context.h"
#include "Bandwidth.h"
#include "Network.h"
#include "aac.h"

#define MAX_BUFFER 8192
#define AAC_PAYLOAD_TYPE 96

class CAACEncoder : public CAac
{
  // libfaac
  faacEncHandle faac_handle;
  faacEncConfigurationPtr faac_cfg;
  unsigned long samples_input;
  unsigned long max_bytes_output;
  uint8_t out[MAX_BUFFER], tmp[MAX_BUFFER];
  uint32_t index;
  // RTP
  RTPNetwork rtp;
  Bandwidth bwt;
  AVRTP_CONTEXT *cntx;
public:
  CAACEncoder();
  virtual ~CAACEncoder();
  int32_t Open(AVRTP_CONTEXT *cntx);
  int32_t Encode(int16_t *inp, uint32_t inp_size);
  int32_t Close();
};

#endif
