/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/
//---------------------------------------------------------------------------

#include "aac.h"
//---------------------------------------------------------------------------

// ctor
CAac::CAac()
{
  // load library
  hDll = ::LoadLibrary(_T("libfaac.dll"));
  if(hDll)
  {
    // get functions
    _faacEncGetVersion = (faacEncGetVersion *)::GetProcAddress(hDll, "faacEncGetVersion");
    _faacEncGetCurrentConfiguration = (faacEncGetCurrentConfiguration *)::GetProcAddress(hDll, "faacEncGetCurrentConfiguration");
    _faacEncSetConfiguration = (faacEncSetConfiguration *)::GetProcAddress(hDll, "faacEncSetConfiguration");
    _faacEncOpen = (faacEncOpen *)::GetProcAddress(hDll, "faacEncOpen");
    _faacEncGetDecoderSpecificInfo = (faacEncGetDecoderSpecificInfo *)::GetProcAddress(hDll, "faacEncGetDecoderSpecificInfo");
    _faacEncEncode = (faacEncEncode *)::GetProcAddress(hDll, "faacEncEncode");
    _faacEncClose = (faacEncClose *)::GetProcAddress(hDll, "faacEncClose");
  }
  else
  {
    ::MessageBox(NULL, _T("Cannot load libfaac.dll"), _T("Error"), MB_OK);
    exit(0);
  }
}
//---------------------------------------------------------------------------

// dtor
CAac::~CAac()
{
  // free library
  if(hDll)
  {
    ::FreeLibrary(hDll);
    hDll = NULL;
  }
}
//---------------------------------------------------------------------------


