/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef AACH
#define AACH

#include <windows.h>
#include <stdint.h>
#include <tchar.h>
#include "faac.h"

//---------------------------------------------------------------------------
typedef int FAACAPI (faacEncGetVersion)(char **faac_id_string, char **faac_copyright_string);
typedef faacEncConfigurationPtr FAACAPI (faacEncGetCurrentConfiguration)(faacEncHandle hEncoder);
typedef int FAACAPI (faacEncSetConfiguration)(faacEncHandle hEncoder, faacEncConfigurationPtr config);
typedef faacEncHandle FAACAPI (faacEncOpen)(unsigned long sampleRate, unsigned int numChannels, unsigned long *inputSamples, unsigned long *maxOutputBytes);
typedef int FAACAPI (faacEncGetDecoderSpecificInfo)(faacEncHandle hEncoder, unsigned char **ppBuffer, unsigned long *pSizeOfDecoderSpecificInfo);
typedef int FAACAPI (faacEncEncode)(faacEncHandle hEncoder, short* inputBuffer, unsigned int samplesInput, unsigned char *outputBuffer, unsigned int bufferSize);
typedef int FAACAPI (faacEncClose)(faacEncHandle hEncoder);
//---------------------------------------------------------------------------

class CAac
{
  HINSTANCE hDll;
protected:
  faacEncGetVersion *_faacEncGetVersion;
  faacEncGetCurrentConfiguration *_faacEncGetCurrentConfiguration;
  faacEncSetConfiguration *_faacEncSetConfiguration;
  faacEncOpen *_faacEncOpen;
  faacEncGetDecoderSpecificInfo *_faacEncGetDecoderSpecificInfo;
  faacEncEncode *_faacEncEncode;
  faacEncClose *_faacEncClose;
public:
  CAac();
  virtual ~CAac();
};

//---------------------------------------------------------------------------
#endif


