/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#include "avc.h"
//---------------------------------------------------------------------------

// ctor
CAvc::CAvc()
{
  // load library
  TCHAR libName[] = _T("libx264-136.dll");
  hDll = ::LoadLibrary(libName);
  if(hDll)
  {
    // get functions
    h264_param_default = (x264_param_default *)::GetProcAddress(hDll, "x264_param_default");
    h264_param_default_preset = (x264_param_default_preset *)::GetProcAddress(hDll, "x264_param_default_preset");
    h264_param_parse = (x264_param_parse *)::GetProcAddress(hDll, "x264_param_parse");
    h264_picture_alloc = (x264_picture_alloc *)::GetProcAddress(hDll, "x264_picture_alloc");
    h264_picture_clean = (x264_picture_clean *)::GetProcAddress(hDll, "x264_picture_clean");
    h264_picture_init = (x264_picture_init *)::GetProcAddress(hDll, "x264_picture_init");
    h264_nal_encode = (x264_nal_encode *)::GetProcAddress(hDll, "x264_nal_encode");
    h264_encoder_open = (x264_encoder_open *)::GetProcAddress(hDll, "x264_encoder_open_136");
    h264_encoder_reconfig = (x264_encoder_reconfig *)::GetProcAddress(hDll, "x264_encoder_reconfig");
    h264_encoder_headers = (x264_encoder_headers *)::GetProcAddress(hDll, "x264_encoder_headers");
    h264_encoder_encode = (x264_encoder_encode *)::GetProcAddress(hDll, "x264_encoder_encode");
    h264_encoder_close = (x264_encoder_close *)::GetProcAddress(hDll, "x264_encoder_close");
    h264_threading_init = (x264_threading_init *)::GetProcAddress(hDll, "x264_threading_init");
    h264_param_apply_profile = (x264_param_apply_profile *)::GetProcAddress(hDll, "x264_param_apply_profile");
    h264_param_apply_fastfirstpass = (x264_param_apply_fastfirstpass *)::GetProcAddress(hDll, "x264_param_apply_fastfirstpass");
    h264_encoder_parameters = (x264_encoder_parameters *)::GetProcAddress(hDll, "x264_encoder_parameters");
  }
  else
  {
    ::MessageBox(NULL, _tcscat(_T("Cannot load "), libName), _T("Error"), MB_OK);
    exit(0);
  }
}
//---------------------------------------------------------------------------

// dtor
CAvc::~CAvc()
{
  // free library
  if(hDll)
  {
    ::FreeLibrary(hDll);
    hDll = NULL;
  }
}
//---------------------------------------------------------------------------


