/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef AVCH
#define AVCH

#include <windows.h>
#include <stdint.h>
#include <tchar.h>
#include "x264.h"

//---------------------------------------------------------------------------
typedef void    (x264_param_default)( x264_param_t * );
typedef int     (x264_param_default_preset)( x264_param_t *, const char *, const char * );
typedef int     (x264_param_parse)( x264_param_t *, const char *, const char * );
typedef int     (x264_picture_alloc)( x264_picture_t *, int , int , int  );
typedef void    (x264_picture_clean)( x264_picture_t * );
typedef void    (x264_picture_init)( x264_picture_t * );
typedef void    (x264_nal_encode)( x264_t *, uint8_t *, x264_nal_t * );
typedef x264_t *(x264_encoder_open)( x264_param_t * );
typedef int     (x264_encoder_reconfig)( x264_t *, x264_param_t * );
typedef int     (x264_encoder_headers)( x264_t *, x264_nal_t **, int * );
typedef int     (x264_encoder_encode)( x264_t *, x264_nal_t **, int *, x264_picture_t *, x264_picture_t * );
typedef void    (x264_encoder_close)( x264_t * );
typedef void    (x264_threading_init)( );
typedef int     (x264_param_apply_profile)( x264_param_t *, const char *profile );
typedef void    (x264_param_apply_fastfirstpass)( x264_param_t * );
typedef void    (x264_encoder_parameters)( x264_t *, x264_param_t * );

//---------------------------------------------------------------------------

class CAvc
{
  HINSTANCE hDll;
protected:
  x264_param_default *h264_param_default;
  x264_param_default_preset *h264_param_default_preset;
  x264_param_parse *h264_param_parse;
  x264_picture_alloc *h264_picture_alloc;
  x264_picture_clean *h264_picture_clean;
  x264_picture_init *h264_picture_init;
  x264_nal_encode *h264_nal_encode;
  x264_encoder_open *h264_encoder_open;
  x264_encoder_reconfig *h264_encoder_reconfig;
  x264_encoder_headers *h264_encoder_headers;
  x264_encoder_encode *h264_encoder_encode;
  x264_encoder_close *h264_encoder_close;
  x264_threading_init *h264_threading_init;
  x264_param_apply_profile *h264_param_apply_profile;
  x264_param_apply_fastfirstpass *h264_param_apply_fastfirstpass;
  x264_encoder_parameters *h264_encoder_parameters;
public:
  CAvc();
  virtual ~CAvc();
};

//---------------------------------------------------------------------------
#endif
