/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef CONTEXTH
#define CONTEXTH

#include <windows.h>
#include <stdint.h>
#include <winsock2.h>
#include <ws2tcpip.h>
#include <tchar.h>
#include "Callback.h"
#include "Logo.h"

#define ONESECOND100NANO 10000000ULL

typedef struct
{
  uint8_t mode;
  // RTSP
  int8_t host[128];
  int32_t port;
  int8_t path[128];
  int8_t sdp[1024];
  int8_t username[64];
  int8_t password[64];
  int8_t realm[128];
  int32_t ok;
  // RTP
  uint8_t ttl;
  uint32_t mtu;
  uint8_t cast;
  // video
  int8_t v_host[128];
  int32_t v_port;
  // audio
  int8_t a_host[128];
  int32_t a_port;
  int32_t a_obj;
  // DirectShow Capture
  // audio
  uint32_t a;
  TCHAR audio_source[128];
  LPWAVEFORMATEX wfx;
  int32_t a_bit_rate;
  int32_t a_band_width;
  int32_t frame_size;
  CCallback *a_call;
  // video
  int8_t change_rate;
  uint32_t v;
  TCHAR video_source[128];
  int32_t frame_rate;
  int32_t v_bit_rate;
  int32_t key_frame_rate;
  int32_t width;
  int32_t height;
  CCallback *v_call;
  // renderer
  RECT r;
  HWND hWnd;
  int8_t preview;
  // h264
  int8_t preset;
  int8_t tune;
  int8_t tune1;
  int8_t tune2;
  int8_t profile;
  CLogo *logo;
  int8_t draw;
  // bandwidth
  double audio_bw;
  double video_bw;
  // license
} AVRTP_CONTEXT;

#endif