/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#include "AudioIn.h"

CAudioIn::CAudioIn(AVRTP_CONTEXT *c) : CCallback()
{
  cntx = c;
  int32_t sample_size = enc.Open(cntx);
  cntx->frame_size = cntx->mtu * sample_size * sizeof(short);
}

CAudioIn::~CAudioIn()
{
  enc.Close();
}

/*
STDMETHODIMP CAudioIn::BufferCB(double Time, BYTE *pBuffer, long BufferLen)
{
  enc.Encode((short *)pBuffer, BufferLen / sizeof(short));
  return 0;
}
*/

STDMETHODIMP CAudioIn::BufferCB(double Time, BYTE *pBuffer, long BufferLen)
{
  buf.put(pBuffer, BufferLen);
  unsigned char *chunk = (unsigned char *)malloc(cntx->frame_size);
  while(buf.get(chunk, cntx->frame_size))
  {
    enc.Encode((short *)chunk, cntx->frame_size / sizeof(short));
  }
  free(chunk);
  return 0;
}

