/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef BASECAPTUREH
#define BASECAPTUREH

#include "context.h"
#include <dshow.h>
#include <qedit.h>
#include <dvdmedia.h>
#include <xprtdefs.h>

#ifndef SAFE_RELEASE
#define SAFE_RELEASE(x)  \
  if(NULL != x)          \
  {                      \
    x->Release();        \
    x = NULL;            \
  }
#endif

class CBaseCapture
{
protected:
  HRESULT hr;
  // graph
  IGraphBuilder *pGraph;
  ICaptureGraphBuilder2 *pBuilder;
  IMediaControl *pControl;
  IMediaEvent *pEvent;
  BOOL AddSource(REFCLSID Category, LPTSTR Device,
      IBaseFilter **pFilter, LPTSTR Name);
  BOOL AddGrabber(IBaseFilter **pFilter, LPTSTR Name,
      ISampleGrabber **pGrabber);
  BOOL AddRenderer(GUID guid, IBaseFilter **pFilter, LPTSTR Name);
  BOOL FilterProperty(HWND hWnd, IBaseFilter **pFilter);
public:
  // ctor
  CBaseCapture();
  virtual ~CBaseCapture();
  // graph
  BOOL Start();
  BOOL Stop();
  // error
  LPCTSTR GetLastError();

  void WINAPI DeleteMediaType(AM_MEDIA_TYPE *pmt);
  void WINAPI FreeMediaType(AM_MEDIA_TYPE& mt);

};

#endif;