/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#include "Callback.h"

// Iunknown implementation
STDMETHODIMP_(ULONG) CCallback::AddRef()
{
  return 1;
}

STDMETHODIMP_(ULONG) CCallback::Release()
{
  return 0;
}

STDMETHODIMP CCallback::QueryInterface(REFIID riid, void **ppvObject)
{
  if (NULL == ppvObject)
  {
    return E_POINTER;
  }
  if (riid == __uuidof(IUnknown))
  {
    *ppvObject = static_cast<IUnknown*>(this);
    return S_OK;
  }
  if (riid == __uuidof(ISampleGrabberCB))
  {
    *ppvObject = static_cast<ISampleGrabberCB*>(this);
    return S_OK;
  }
  return E_NOTIMPL;
}
// 0
STDMETHODIMP CCallback::SampleCB(double Time, IMediaSample *pSample)
{
  return 0;
}



