/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef DeviceH
#define DeviceH

#include <dshow.h>
#include <qedit.h>
#include <tchar.h>

#ifndef SAFE_RELEASE

#define SAFE_RELEASE(x)  \
  if(NULL != x)          \
  {                      \
    x->Release();        \
    x = NULL;            \
  }

#endif

class CDevice
{
  static void FindSources(HWND hWnd, REFCLSID ClassID);
public:
  static void GetAudioSources(HWND hWnd);
  static void GetVideoSources(HWND hWnd);
};

#endif;