/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/
//---------------------------------------------------------------------------

#ifndef LOGOH
#define LOGOH

#include <windows.h>
#include <tchar.h>
#include <Gdiplus.h>

#define MAX_DX 128
#define MAX_DY 128
//---------------------------------------------------------------------------

class CLogo
{
  ULONG_PTR token;
  Gdiplus::GdiplusStartupInput gdi;
  Gdiplus::BitmapData bitmapData;
  Gdiplus::Bitmap *bmp;
  Gdiplus::Status status;

  RGBQUAD t;
  RGBQUAD *logo;
  int x, y, dx, dy;
  int mode;
  BOOL bOpaque;
  BOOL isTransparentColor(RGBQUAD r);
  BOOL CalcPosition(int width, int height);
  BOOL GetImage();
  void CancelLogo();
  BITMAPINFOHEADER bi;
public:
  CLogo();
  virtual ~CLogo();
  void SetPosition(int m) { mode = m; };
  void DrawLogo(RGBTRIPLE *frame, int width, int height);
  void LoadLogo(LPTSTR file);
  void Abort();
  void SetXPos(int p = 8) { dx = p; };
  void SetYPos(int p = 8) { dy = p; };
  void SetOpaque(BOOL o = FALSE) { bOpaque = o; };
  LPBITMAPINFOHEADER GetFormat() { return &bi; };
  RGBQUAD *GetData() { return logo; };
};

#endif
//---------------------------------------------------------------------------

