/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#include "VideoIn.h"

CVideoIn::CVideoIn(AVRTP_CONTEXT *c) : CCallback()
{
  cntx = c;
  enc.Open(cntx);
}

CVideoIn::~CVideoIn()
{
  enc.Close();
}

STDMETHODIMP CVideoIn::BufferCB(double Time, BYTE *pBuffer, long BufferLen)
{
  if(cntx->draw)
  {
    cntx->logo->DrawLogo((RGBTRIPLE *)pBuffer, cntx->width, cntx->height);
  }
  enc.Encode(pBuffer, BufferLen);
  return 0;
}

