/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef RTPTIMEH
#define RTPTIMEH

#include <windows.h>
#include <stdint.h>
#include <limits.h>

#define TWO_SECONDS 2000000ULL
#define TIME_BASE 1000000ULL
#define DELTA_EPOCH_IN_MICROSECS  11644473600000000ULL
#define NTP_OFFSET 2208988800ULL
#define NTP_OFFSET_US 2208988800000000ULL

#define SS(v)(v / TIME_BASE)
#define UU(v)(v % TIME_BASE)

class RTPTime
{
  uint64_t ft, tmp;
protected:
  uint32_t clock_freq;
  uint64_t base_ntp_time;
  uint64_t last_sr_time;
  uint32_t base_rtp_time;
public:
  RTPTime();
  virtual ~RTPTime();
  uint64_t gettimeofday();
  int gettimeofday(struct timeval *tv);
  uint64_t ntp_time();
  void ntp_time(uint32_t &sec, uint32_t &usec, uint64_t time);
  uint32_t rescale(int64_t time);
  void SetClock(uint32_t clock);
  uint32_t rtp_time();
  uint32_t sr(uint64_t time);
  uint32_t random();
};

#endif