/*
* RTP/RTCP H264/MPEG-4 AAC Encoder
* Copyright (c) 2008 Marius Gligor
*
* Author: Marius Gligor <marius.gligor@gmail.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
*/

#ifndef SESSH
#define SESSH

#include "context.h"
#include "rtsp.h"

#define HTTP_OK 200
#define HTTP_AUTH 401

class CSess : public CRtsp, CAuth
{
  int Announce();
  int Announce(char *sid);
  int Authorization();
  int SetupTrack1();
  int SetupTrack2();
  int Play();
  int Stop();

  char uri[1024];
  char key[1024];
  char sess_id[64];

  int seq, z;
  AVRTP_CONTEXT *cntx;
public: // User declarations
  CSess();
  virtual ~CSess();

  int Open(AVRTP_CONTEXT *cntx);
  int Close();
};
#endif
